ServerSocketFactory (Java SE 26 & JDK 26)
Description: declaration: module: java.base, package: javax.net, class: ServerSocketFactory
Keywords: javax.net.ServerSocketFactory class

# Class ServerSocketFactory

java.lang.Object
javax.net.ServerSocketFactory

Direct Known Subclasses:
  `SSLServerSocketFactory`

public abstract class ServerSocketFactory extends Object
This class creates server sockets. It may be subclassed by other factories, which create particular types of server sockets. This provides a general framework for the addition of public socket-level functionality. It is the server side analogue of a socket factory, and similarly provides a way to capture a variety of policies related to the sockets being constructed.

Like socket factories, server Socket factory instances have methods used to create sockets. There is also an environment specific default server socket factory; frameworks will often use their own customized factory.

Since:
  1.4
See Also:
  - `SocketFactory`

- ## Constructor Summary

  Constructors
  Modifier
  Constructor
  Description
  `protected`
  `ServerSocketFactory()`
  Creates a server socket factory.

- ## Method Summary

  Modifier and Type
  Method
  Description
  `ServerSocket`
  `createServerSocket()`
  Returns an unbound server socket.
  `abstract ServerSocket`
  `createServerSocket(int port)`
  Returns a server socket bound to the specified port.
  `abstract ServerSocket`
  `createServerSocket(int port, int backlog)`
  Returns a server socket bound to the specified port, and uses the specified connection backlog.
  `abstract ServerSocket`
  `createServerSocket(int port, int backlog, InetAddress ifAddress)`
  Returns a server socket bound to the specified port, with a specified listen backlog and local IP.
  `static ServerSocketFactory`
  `getDefault()`
  Returns a copy of the environment's default socket factory.

  ### Methods declared in class Object

  `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`
  Modifier and Type
  Method
  Description
  `protected Object`
  `clone()`
  Creates and returns a copy of this object.
  `boolean`
  `equals(Object obj)`
  Indicates whether some other object is "equal to" this one.
  `protected void`
  `finalize()`
  Deprecated, for removal: This API element is subject to removal in a future version.
  Finalization is deprecated and subject to removal in a future release.
  `final Class<?>`
  `getClass()`
  Returns the runtime class of this `Object`.
  `int`
  `hashCode()`
  Returns a hash code value for this object.
  `final void`
  `notify()`
  Wakes up a single thread that is waiting on this object's monitor.
  `final void`
  `notifyAll()`
  Wakes up all threads that are waiting on this object's monitor.
  `String`
  `toString()`
  Returns a string representation of the object.
  `final void`
  `wait()`
  Causes the current thread to wait until it is awakened, typically by being notified or interrupted.
  `final void`
  `wait(long timeoutMillis)`
  Causes the current thread to wait until it is awakened, typically by being notified or interrupted, or until a certain amount of real time has elapsed.
  `final void`
  `wait(long timeoutMillis, int nanos)`
  Causes the current thread to wait until it is awakened, typically by being notified or interrupted, or until a certain amount of real time has elapsed.

- ## Constructor Details

  - ### ServerSocketFactory

    protected ServerSocketFactory()
    Creates a server socket factory.

- ## Method Details

  - ### getDefault

    public static ServerSocketFactory getDefault()
    Returns a copy of the environment's default socket factory.
    Returns:
      the `ServerSocketFactory`

  - ### createServerSocket

    public ServerSocket createServerSocket() throws IOException
    Returns an unbound server socket. The socket is configured with the socket options (such as accept timeout) given to this factory.
    Returns:
      the unbound socket
    Throws:
      `IOException` - if the socket cannot be created
    See Also:
      - `ServerSocket.bind(java.net.SocketAddress)`
      - `ServerSocket.bind(java.net.SocketAddress, int)`
      - `ServerSocket()`

  - ### createServerSocket

    public abstract ServerSocket createServerSocket(int port) throws IOException
    Returns a server socket bound to the specified port. The socket is configured with the socket options (such as accept timeout) given to this factory.
    Parameters:
      `port` - the port to listen to
    Returns:
      the `ServerSocket`
    Throws:
      `IOException` - for networking errors
      `IllegalArgumentException` - if the port parameter is outside the specified range of valid port values, which is between 0 and 65535, inclusive.
    See Also:
      - `ServerSocket(int)`

  - ### createServerSocket

    public abstract ServerSocket createServerSocket(int port, int backlog) throws IOException
    Returns a server socket bound to the specified port, and uses the specified connection backlog. The socket is configured with the socket options (such as accept timeout) given to this factory.

    The `backlog` argument must be a positive value greater than 0. If the value passed if equal or less than 0, then the default value will be assumed.

    Parameters:
      `port` - the port to listen to
      `backlog` - how many connections are queued
    Returns:
      the `ServerSocket`
    Throws:
      `IOException` - for networking errors
      `IllegalArgumentException` - if the port parameter is outside the specified range of valid port values, which is between 0 and 65535, inclusive.
    See Also:
      - `ServerSocket(int, int)`

  - ### createServerSocket

    public abstract ServerSocket createServerSocket(int port, int backlog, InetAddress ifAddress) throws IOException
    Returns a server socket bound to the specified port, with a specified listen backlog and local IP.

    The `ifAddress` argument can be used on a multi-homed host for a `ServerSocket` that will only accept connect requests to one of its addresses. If `ifAddress` is null, it will accept connections on all local addresses. The socket is configured with the socket options (such as accept timeout) given to this factory.

    The `backlog` argument must be a positive value greater than 0. If the value passed if equal or less than 0, then the default value will be assumed.

    Parameters:
      `port` - the port to listen to
      `backlog` - how many connections are queued
      `ifAddress` - the network interface address to use
    Returns:
      the `ServerSocket`
    Throws:
      `IOException` - for networking errors
      `IllegalArgumentException` - if the port parameter is outside the specified range of valid port values, which is between 0 and 65535, inclusive.
    See Also:
      - `ServerSocket(int, int, java.net.InetAddress)`